#include <proc.h>
#include <sched.h>
#include <mittos/graphics.h>
#include <memory.h>
#include <cpu.h>
#include <math.h>

extern gfx_context *term_fb;
extern gfx_context kernel_fb;

int *position = (void *)0x20000;

void thread1() {
  int a = 1;
  double prev = 0;
  gfx_context *ctx =
      framebuffer_make_subcontext(&kernel_fb, 700, 300, 100, 100);
  __asm__("sti");
  while(1) {
    putCharacter(term_fb,
        *position, *position,
        RGB(255,255,0), RGB(0,0,0),
        '0'+(a++%10)
    );
    int s = (current_cpu->timer_ticks/1000)%10;
    double cur = (double)(current_cpu->timer_ticks/100);
    putCharacter(term_fb,
        0, 0,
        RGB(255,255,0), RGB(0,0,0),
        '0'+(s%10)
    );
    flip(term_fb);

    double angle = cur/3.14*2;

    draw_line(ctx, 50, 50 + (int)(50*cos(prev)), 50, 50 + (int)(50*sin(prev)), RGB(0,0,0));
    draw_line(ctx, 50, 50 + (int)(50*cos(angle)), 50, 50 + (int)(50*sin(angle)), RGB(255,0,0));
    prev = angle;
    flip(ctx);
    sched_yield();
  }
}

void thread2() {
  int a = 0;
  gfx_context *ctx =
      framebuffer_make_subcontext(&kernel_fb, 800, 400, 100, 100);
  __asm__("sti");
  while(1) {
    double pos = (double)(current_cpu->timer_ticks/100);
    fill_rect(ctx, 0, 0, 100, 100, 0);
    for(int i = 0; i < 10000; i++) {
      putpixel(ctx, i/100, 50 + (int)(50.0*sin(pos + ((double)i)/1000.0)), RGB(0,0,255));
      putpixel(ctx, i/100, 50 + (int)(50.0*cos(pos + ((double)i)/1000.0)), RGB(255,0,0));
    }
    flip(ctx);
    putCharacter(term_fb,
        *position, *position,
        RGB(0,255,255), RGB(0,0,0),
        'A'+(a++%10)
    );
    flip(term_fb);
    sched_yield();
  }
}


void TEMP_test_scheduler() {
  struct process *th1 = new_process(thread1);
  scheduler_insert(th1);

  struct process *th2 = new_process(thread2);
  scheduler_insert(th2);

  uint64_t p1 = pmm_alloc();
  uint64_t p2 = pmm_alloc();
  vmm_set_page(th1->P4, 0x20000, p1, PAGE_PRESENT);
  vmm_set_page(th2->P4, 0x20000, p2, PAGE_PRESENT);
  // Write different values into the position variable for the two processes
  int *a = P2V(p1);
  *a = 20;
  a = P2V(p2);
  *a = 70;
}