#include <cpu.h>
#include <ports.h>
#include <multiboot.h>

struct cpu *cpus[16];
struct ioapic ioapic = {0,0,0};
uint8_t irq_redirects[MAX_IRQS] = {
    0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12,
    13, 14, 15, 16, 17, 18, 19, 20, 21, 22, 23
};

#define PIC1_ADDR 0x20
#define PIC2_ADDR 0xA0
static void pic_disable() {
  // Mask all interrupts
  outb(PIC1_ADDR | 1, 0xFF);
  outb(PIC2_ADDR | 1, 0xFF);
}

void early_cpu_init() {
  interrupt_init();
}

void cpu_init() {
  acpi_parse(kernel_boot_data.rsdp);
  pic_disable();
  apic_init();
  ioapic_init();
  timer_init();
  sse_init();
}